django_traning/django_traning/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('my_app.urls')),
]

django_traning/my_app/urls.py
from django.urls import path
from .views import *

urlpatterns = [
    path('home/', home, name = 'home'),
    path('create/', create, name = 'create'),
    path('list/', list, name = 'list'),
]

django_traning/my_app/models.py
from django.db import models
from django.db.models.fields import CharField
from django.utils.translation import gettext_lazy
from datetime import date
# Create your models here.

class School(models.Model):
    name = models.CharField(max_length=100)
    class Grade(models.TextChoices):
        primary = 'PR', gettext_lazy('Primary School')
        secondary = 'SE', gettext_lazy('Secondary School')
        high = 'HI', gettext_lazy('High School')
    grade = models.CharField(max_length=2, choices=Grade.choices, default=Grade.primary)
    def __str__(self):
        return self.name
    class Meta:
        verbose_name = 'schools'
        verbose_name_plural = 'schools'

class Class(models.Model):
    name = models.CharField(max_length=100)
    Grade = models.CharField(max_length=2)
    schoolid = models.ForeignKey('School', on_delete=models.CASCADE)
    def __str__(self):
        return (self.Grade + '-' + self.name)
    class Meta:
        verbose_name = 'classes'
        verbose_name_plural = 'classes'

class Student(models.Model):
    name = models.CharField(max_length=100)
    dateOfBirth = models.DateField()
    class Sex(models.TextChoices):
        male = 'M', gettext_lazy('Male')
        female = 'F', gettext_lazy('Female')
    sex = models.CharField(max_length=1, choices=Sex.choices, default=Sex.male)
    currentClassId = models.ForeignKey('Class', on_delete=models.CASCADE, null=True)
    def __str__(self):
        return self.name
    class Meta:
        verbose_name = 'students'
        verbose_name_plural = 'students'

django_traning/my_app/forms.py
from django import forms
from .models import Class
import json
from .models import Student

class CreateStudent(forms.Form):
    name = forms.CharField(label = 'Name', max_length=100, required=True)
    dateOfBirth = forms.DateField(label = 'Birthday', required=True)
    sex_choices = [
        (Student.Sex.male, 'M'),
        (Student.Sex.female, 'F'),
    ]
    sex = forms.ChoiceField(label = 'Sex', choices=sex_choices, required=True, widget=forms.Select)
    class_list = Class.objects.all()
    class_choices = []

    for i in class_list:
        class_choices.append((i.id, i.Grade + '-' + i.name))
    currentClassId = forms.ChoiceField(label = 'Class', choices=class_choices, required=True, widget=forms.Select)
    class_choices = json.dumps(class_choices)

django_traning/my_app/views.py
from django.shortcuts import render, redirect
from .models import Student, Class
from .forms import CreateStudent
# Create your views here.

def home(request):
    return render(request, 'my_app/home.html', {})

def create(request):
    if request.method == 'POST':
        form = CreateStudent(request.POST)
        if form.is_valid():
            data = form.cleaned_data
            student = Student(name = data['name'], dateOfBirth = data['dateOfBirth'], sex = data['sex'], currentClassId = Class.objects.get(id = int(data['currentClassId'])))
            student.save()
        return redirect('/home')
    else:
        form = CreateStudent()
    return render(request, 'my_app/create.html', {'form': form})

def list(request):
    class_list = Class.objects.all()
    return render(request, 'my_app/list.html', {'class_list': class_list})

django_traning/django_traning/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    {% block js %}
    {% endblock %}
    <title>{% block title %}Base{% endblock %}</title>
</head>
<body>
    <div>
        <ul>
            <li><a href="/home">Home</a></li>
            <li><a href="/create">Create</a></li>
            <li><a href="/list">List</a></li>
        </ul>
    </div>
    {% block content %}
    {% endblock %}
</body>
</html>

django_traning/my_app/templates/my_app/create.html
{% extends 'base.html' %}

{% block title %}
    Create
{% endblock %}

{% block js %}
<script>
    window.onload = function(){
        const dateOfBirth = document.getElementById('id_dateOfBirth');
        dateOfBirth.addEventListener('change', function(){
            var yearOfBirth = parseInt(dateOfBirth.value.split('-')[0]);
            var today = new Date();
            var yearOfToday = today.getFullYear();
            var age = yearOfToday - yearOfBirth;
            var gradeOfStudent = age - 5
            console.log(age);
            var classChoices = {{form.class_choices|safe}};
            console.log(classChoices);
            var filteredClassChoices = classChoices.filter(function(choice){
                return choice[1].split('-')[0] == gradeOfStudent;
            });
            console.log(filteredClassChoices);
            const currentClassId = document.getElementById('id_currentClassId');
            currentClassId.innerHTML = '<option value = "" disabled selected>Select a class</option>';
            for(let [g, n] of Object.entries(filteredClassChoices)){
                currentClassId.insertAdjacentHTML('beforeend', '<option value = "'+ n[0] + '">'+ n[1] +'</option>');
            }
            currentClassId.addEventListener('change', function(){
                console.log(currentClassId.value);
            });
        });
        // const currentClassId = document.getElementById('id_currentClassId');
        // currentClassId.addEventListener('change', function(){
        //     var yearOfBirth = parseInt(dateOfBirth.value.split('-')[0]);
        //     var today = new Date();
        //     var yearOfToday = today.getFullYear();
        //     var age = yearOfToday - yearOfBirth;
        //     var gradeOfStudent = age - 5;
        //     var gradeOfClass = parseInt(currentClassId.value);
        //     if(gradeOfClass != gradeOfStudent){
        //         console.log('this student can not choose this grade');
        //     }
        //     else{
        //         console.log('right choice');
        //     }
        // });
    };
</script>
{% endblock %}
{% block content %}
    <h1>Create</h1>
    <form action="/create/" method="post">
        {% csrf_token %}
        {{form.as_p}}
        <input type="submit" value="Submit">
    </form>
{% endblock %}

django_traning/my_app/templates/my_app/home.html
{% extends 'base.html' %}

{% block title %}
    Home
{% endblock %}

{% block content %}
    <h1>Hello</h1>
{% endblock %}

django_traning/my_app/templates/my_app/list.html
{% extends 'base.html' %}

{% block title %}
    List
{% endblock %}

{% block content %}
    <h1>List</h1>
    {% for i in class_list %}
    <h3>{{i.Grade}}-{{i.name}}</h3>
        {% for j in i.student_set.all %}
            {{j.name}} <br>
        {% endfor %}
    {% endfor %}
{% endblock %}